EDIT - bug #7856

Allow local override for distribution vocabularies
10/23/2018 05:59 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.5

Severity: critical Found in Version:

Description

copied from #7235

Currently local override for TaxDistributionEditor areas allows only to further reduce the vocabularies defined in DB preferences.
However, local override means that preferences can be overriden. So one may choose also other vocabularies, not selected in DB

prefs.

So, with local override selected, always all vocabularies should be shown here.

Another question is the behavior if allow override is false. Then the button should be disabled | think. Fine tuning of areas is always
possible via the area selection WITHIN the DistributionEditor therefore a second vocabulary filter is not needed.

Related issues:

Related to EDIT - task #7854: Open issues in TaxDistributionEditor

Related to EDIT - bug #7999: Allow override does not work correctly for distr...
Related to EDIT - bug #7880: Implement centralized preference default loading...
Related to EDIT - bug #7849: Improve DB Preferences handling and saving in Ta...
Related to EDIT - feature request #8045: Improve handling of default values a...
Copied from EDIT - feature request #7235: Make available area vocabularies a ...

Closed
Closed
Closed
Closed
Feedback
Closed

Associated revisions

Revision eade8b7d - 12/20/2018 11:21 AM - Katja Luther

ref #7856: fix allow override for namedArea vocabulary selection for distributions

Revision 7ffc533f - 12/20/2018 11:56 AM - Katja Luther

ref #7856: fix allow override for namedArea vocabulary selection for distributions

Revision e398666b - 01/28/2019 12:09 PM - Katja Luther

fix problems in preferences views

Revision f10b2ba0 - 01/31/2019 04:36 PM - Katja Luther

ref #7856: in admin preference keep distribution editor prefs enabled if the activation is disabled

Revision 0613242b - 02/05/2019 09:52 AM - Katja Luther
fix #7856: fix NPE

History

#1 - 10/23/2018 06:04 PM - Andreas Miuller

- Copied from feature request #7235: Make available area vocabularies a database preference for TaxEditor distribution editor added

#2 - 10/23/2018 06:07 PM - Andreas Miuller

- Severity changed from normal to critical

NOTE: currently when using the local preferences and deselecting some areas they are not shown anymore when you next time open the selection

dialog. Therefore it is not possible to "reselect" (only by restoring to default, but | have not tested this).

This is CRITICAL.
#3 - 10/23/2018 06:08 PM - Andreas Miiller
- Related to task #7854: Open issues in TaxDistributionEditor added

#4 - 12/20/2018 11:58 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

now it is possible to override the available vocabularies for the distribution editor.please review

#5 - 12/20/2018 11:58 AM - Katja Luther
- % Done changed from 0 to 50

#6 - 01/17/2019 11:31 AM - Andreas Miiller

- Related to bug #7999: Allow override does not work correctly for distribution areas added

#7 - 01/17/2019 12:32 PM - Andreas Miiller
- Related to bug #7880: Implement centralized preference default loading strategy added

#8 - 01/17/2019 12:33 PM - Andreas Miiller

See #7880#note-8 , local override or preference does not yet work fully correct

#9 - 01/17/2019 12:34 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

#10 - 01/17/2019 12:42 PM - Andreas Miiller

Andreas Muller wrote:

See #7880#note-8 , local override or preference does not yet work fully correct

this is about status, not areas, however similar as the issue of this ticket.

#11 - 01/23/2019 01:59 PM - Katja Luther

- Status changed from Feedback to Resolved

this should be fixed for distribution vocabularies and status.

#12 - 01/23/2019 03:23 PM - Andreas Miiller

should | do remove or are there remaining open issues?

#13 - 01/23/2019 03:27 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

please review, the other ticket was already closed, so | closed it again and the issue about the problems when there is no db preference is handled in
this ticket.

#14 - 01/27/2019 08:39 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

Now after selecting another vocabulary (without override flag set, but this is probably not important) and then saving the preferences | got

login : admin

editor version : 5.5.0.201901242349

server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.0.0.0.20180514

os : Windows Server 2012 R2 6.3 amdo64

java : 1.8.0_121

java.lang.NullPointerException
org.eclipse.core.internal.preferences.EclipsePreferences.put (EclipsePreferences. java:859)
org.eclipse.ui.preferences.ScopedPreferenceStore.setValue (ScopedPreferenceStore. java:639)
eu.etaxonomy.taxeditor.preference.PreferencesUtil.setStringValue (PreferencesUtil. java:126)
eu.etaxonomy.taxeditor.preference.PreferencesUtil.setDisplayStatusInChecklistEditor (PreferencesUtil. jav

eu.etaxonomy.taxeditor.preference.ChecklistEditorGeneralPreference.performOk (ChecklistEditorGeneralPref
java:438)

org.eclipse.jface.preference.PreferenceDialog$8.run (PreferenceDialog. java:905)
org.eclipse.core.runtime.SafeRunner.run (SafeRunner. java:42)
org.eclipse.ui.internal.JFaceUtil$l.run (JFaceUtil. java:50)

org.eclipse.jface.util.SafeRunnable.run (SafeRunnable.java:173)
org.eclipse.jface.preference.PreferenceDialog.okPressed(PreferenceDialog. java:889)
org.eclipse.jface.preference.PreferenceDialog.buttonPressed (PreferenceDialog. java:230)
org.eclipse.jface.dialogs.Dialog$2.widgetSelected(Dialog. java:618)
org.eclipse.swt.widgets.TypedListener.handleEvent (TypedListener. java:249)
org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)
org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)
org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)
org.eclipse.swt.widgets.Display.readAndDispatch (Display. java:3824)
org.eclipse.jface.window.Window.runEventLoop (Window. java:818)
org.eclipse.jface.window.Window.open (Window. java:794)
eu.etaxonomy.taxeditor.workbench.handler.OpenPreferencesHandler.execute (OpenPreferencesHandler. java:124

sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)
org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)
org.eclipse.e4.core.internal.di.InjectorImpl.invoke (InjectorImpl.java:264)
org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:132)
org.eclipse.ed4.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. java:152)
org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)
org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:488)
org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServicelImpl. java:210)
org.eclipse.e4.ui.workbench.renderers.swt.HandledContributionItem.executeltem (HandledContributionItem. j

ava:433)

at

org.eclipse.e4.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (AbstractContri

butionItem. java:454)
org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)
org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)
org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)
org.eclipse.swt.widgets.Display.readAndDispatch (Display. java:3824)
org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)
org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
org.eclipse.ed4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)
org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)
org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)
org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)
eu.etaxonomy.taxeditor.Application.start (Application. java:24)
org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher.java:134

org.eclipse.core.runtime.internal.adaptor.EclipseApplauncher.start (EclipseAppLauncher.java:104)
org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)
org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)
org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)
org.eclipse.equinox.launcher.Main.run (Main. java:1519)

#15 - 01/27/2019 08:48 AM - Andreas Miiller
- Related to bug #7849: Improve DB Preferences handling and saving in TaxEditor added
#16 - 01/27/2019 08:49 AM - Andreas Miiller
Also there is a related issue: if in DB prefs "Activate Distribuiton Editor" does not allow override the complete page is not shown in local prefs. This
does not make sense. Maybe it is acceptable if activation is switched off as the page is not relevant then.

A better solution might be to disable those preferences which do not allow override. We can't do this on page level. Maybe needs discussion if there
are even better solutions.

Maybe there is a better ticket for this (e.g. #7849). If yes please move.

#17 - 01/31/2019 04:39 PM - Katja Luther

now in admin preferences it is possible to set the distribution editor preferences even if activation is disabled. Locally | think this makes no sense
because if the user does not want to use the distribution editor it is not necessary to set the preferences.

#18 - 01/31/2019 04:43 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Andreas Muller wrote:

Now after selecting another vocabulary (without override flag set, but this is probably not important) and then saving the preferences | got

login : admin

editor version : 5.5.0.201901242349

server : test.e-taxonomy.eu (edit-test) / rem_conf_am

schema version : 5.0.0.0.20180514

os : Windows Server 2012 R2 6.3 amd64

java : 1.8.0_121

java.lang.NullPointerException
at org.eclipse.core.internal.preferences.EclipsePreferences.put (EclipsePreferences. java:859)
at org.eclipse.ui.preferences.ScopedPreferenceStore.setValue (ScopedPreferenceStore. java:639)

is this still reproducable for you? | can not reproduce it

#19 - 02/04/2019 01:19 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

Katja Luther wrote:

now in admin preferences it is possible to set the distribution editor preferences even if activation is disabled. Locally | think this makes no sense
because if the user does not want to use the distribution editor it is not necessary to set the preferences.

yes | think this is ok. Is it also possible to make the dropdowns grey if disabled? it now looks like they are still enabled (though can't be used). But this
is a minor issue.

Also: we have discussed a new handling of "override" for local preferences. | think there is already a ticket for it. Can you link it?

#20 - 02/04/2019 01:41 PM - Andreas Miiller
- % Done changed from 50 to 90

Katja Luther wrote:
Andreas Miller wrote:
Now after selecting another vocabulary (without override flag set, but this is probably not important) and then saving the preferences | got

login : admin

editor version : 5.5.0.201901242349

server : test.e-taxonomy.eu (edit-test) / rem_conf_am

schema version : 5.0.0.0.20180514

os : Windows Server 2012 R2 6.3 amdé64

jJava : 1.8.0_121

java.lang.NullPointerException
at org.eclipse.core.internal.preferences.EclipsePreferences.put (EclipsePreferences. java:859)
at org.eclipse.ui.preferences.ScopedPreferenceStore.setValue (ScopedPreferenceStore. java:639)
is this still reproducable for you? | can not reproduce it

| also can't reproduce. If this can't be fixed theoretically (via stackirace) we may leave it for now.

#21 - 02/04/2019 01:42 PM - Andreas Miiller

Except for the minor issues in note-19 and -20 this is fixed now and can be closed.
#22 - 02/04/2019 01:56 PM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
now in admin preferences it is possible to set the distribution editor preferences even if activation is disabled. Locally | think this makes no

sense because if the user does not want to use the distribution editor it is not necessary to set the preferences.

yes | think this is ok. Is it also possible to make the dropdowns grey if disabled? it now looks like they are still enabled (though can't be used).
But this is a minor issue.

Also: we have discussed a new handling of "override" for local preferences. | think there is already a ticket for it. Can you link it?

#8045

#23 - 02/04/2019 01:57 PM - Katja Luther

- Related to feature request #8045: Improve handling of default values and override in local preferences added

#24 - 02/05/2019 09:52 AM - Katja Luther
- Status changed from Feedback to Resolved

- % Done changed from 90 to 50

Applied in changeset taxeditor|0613242bb57a30b9079585585f1af2e24a68cab8.

#25 - 02/05/2019 09:52 AM - Katja Luther
- Status changed from Resolved to Feedback

- % Done changed from 50 to 90

Andreas Muller wrote:
Katja Luther wrote:
Andreas Muller wrote:

Now after selecting another vocabulary (without override flag set, but this is probably not important) and then saving the preferences |
got

login : admin

editor version : 5.5.0.201901242349

server : test.e-taxonomy.eu (edit-test) / rem_conf_am

schema version : 5.0.0.0.20180514

os : Windows Server 2012 R2 6.3 amd64

java : 1.8.0_121

java.lang.NullPointerException
at org.eclipse.core.internal.preferences.EclipsePreferences.put (EclipsePreferences. java:859)
at org.eclipse.ui.preferences.ScopedPreferenceStore.setValue (ScopedPreferenceStore. java:639)

is this still reproducable for you? | can not reproduce it

| also can't reproduce. If this can't be fixed theoretically (via stackirace) we may leave it for now.

| added a null check to setStringValue, this should fix the potential NPE
#26 - 02/05/2019 09:52 AM - Katja Luther
- Status changed from Feedback to Closed
- % Done changed from 90 to 100

#27 - 02/05/2019 11:55 AM - Andreas Muller

But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to empty string or by throwing
an according exception)?

#28 - 02/05/2019 12:10 PM - Katja Luther
Andreas Miller wrote:
But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to empty string or by

throwing an according exception)?

but an empty preference is like no preference at all?
#29 - 02/06/2019 10:46 AM - Andreas Muller
Katja Luther wrote:
Andreas Miller wrote:
But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to empty string or by
throwing an according exception)?

but an empty preference is like no preference at all?

Ok, maybe this is true. But if true, can't we normalize and make all null values to emtpy string. And more important: does deleting preferences still
work this way. If you change a preference from an existing object to null is this still reflected with the given implementation? Or is the change simply
ignored?

#30 - 02/06/2019 10:55 AM - Katja Luther
Andreas Miller wrote:
Katja Luther wrote:
Andreas Muller wrote:
But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to empty string
or by throwing an according exception)?

but an empty preference is like no preference at all?

Ok, maybe this is true. But if true, can't we normalize and make all null values to emtpy string. And more important: does deleting preferences
still work this way. If you change a preference from an existing object to null is this still reflected with the given implementation? Or is the change
simply ignored?

yes you are right. so | would set the preference to default?

#31 - 02/06/2019 11:08 AM - Andreas Miiller
- Status changed from Closed to Feedback
- % Done changed from 100 to 90
Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:

Andreas Mller wrote:

But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to empty
string or by throwing an according exception)?
but an empty preference is like no preference at all?

Ok, maybe this is true. But if true, can't we normalize and make all null values to emtpy string. And more important: does deleting
preferences still work this way. If you change a preference from an existing object to null is this still reflected with the given implementation?
Or is the change simply ignored?

yes you are right. so | would set the preference to default?

I am not familiar with the local preferences handling so | do not really know. Isn't it possible to completely delete them if they have default value or is
this what is automatically doen with default values? We should avoid that an explicit value is saved even if it is the current default value. Default
values may change over time. Explicit values don't change the same way while missing values do change together with default values.

#32 - 02/06/2019 11:10 AM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
Andreas Muller wrote:
Katja Luther wrote:
Andreas Miiller wrote:

But what if the value is null for some reason. Can this happen? Should we handle this somehow (e.g. by converting it to
empty string or by throwing an according exception)?

but an empty preference is like no preference at all?

Ok, maybe this is true. But if true, can't we normalize and make all null values to emtpy string. And more important: does deleting
preferences still work this way. If you change a preference from an existing object to null is this still reflected with the given
implementation? Or is the change simply ignored?

yes you are right. so | would set the preference to default?

| am not familiar with the local preferences handling so | do not really know. Isn't it possible to completely delete them if they have default value
or is this what is automatically doen with default values? We should avoid that an explicit value is saved even if it is the current default value.
Default values may change over time. Explicit values don't change the same way while missing values do change together with default values.

I would use the setToDefault Method and then it is handled like the preferences in eclipse.

#33 - 02/06/2019 11:52 AM - Katja Luther

| also had a look how it is handled in eclipse preferenceStore and there a null value is handled like nothing. So nothing is set for the preference:

private void setValue (Properties p, String name, String value) {
Assert.isTrue(p != null && value != null);
p.put (name, value);

#34 - 02/06/2019 12:09 PM - Andreas Miiller

But doesn't Assert throw an exception if one of them is null? This is something else then nothing. Or is the exception caught somehow?

#35 - 02/06/2019 03:17 PM - Katja Luther

No the exception is not caught as long as | can see. But maybe we should handle it the same. Then it is consistent to the eclipse preferences, so null

is not allowed.

#36 - 02/08/2019 12:53 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

I keep it like it was implemented: when the string is null, the default value is used.
#37 - 02/08/2019 06:48 PM - Andreas Miiller

- Status changed from Resolved to Closed

- Assignee changed from Andreas Muiller to Katja Luther
- Priority changed from New to Highest

- % Done changed from 90 to 100

Ok, | am not that deep into the code that | could really decide what the best is. | think we can close this ticket. General behavior will be tested with
#7849 anyway and further improvements will be done with #8045
